// This is my first gnome-shell extension, so it's pretty bare.
// I used  Week Clock Extension as a skeleton for some functions, credit to
// Afriskito ( http://afriskito.net/Gnome3Extensions/Week_Clock/ ).
// This will change the default clock in order to show the currect time, 
// numerical date and week day, using the format: HH:MM:SS YYYY/mm/DD, day
//
// Edited by nvd (naveedguy@gmail.com) on November 25, 2014

const St = imports.gi.St;
const Main = imports.ui.main;
const Mainloop = imports.mainloop;
const Lang = imports.lang;
const gio = imports.gi.Gio;

const UPDATE_INTERVAL = 1000; // every second

function FullClock() {
    this._init();
}

FullClock.prototype = {
    _init: function() {
        // Original clock:
        this.date_menu = Main.panel._dateMenu;
        this.orig_clock = this.date_menu._clock;
        // New clock:
        this.full_clock = new St.BoxLayout();
        this.full_date = new St.Label({ style_class: 'my_date' });
        this.full_day = new St.Label({ style_class: 'my_today' });
        this.full_time = new St.Label({ style_class: 'my_time' });
        this.full_clock.add(this.full_date);
        this.full_clock.add(this.full_day);
        this.full_clock.add(this.full_time);
        //Settings key for seconds/date:
        this.check_options = new gio.Settings({schema: "org.gnome.shell.clock"});

        this.timeout = null;
    },

    MakeClock: function() {
        let now = new Date();

        // Check if date should be displayed:
        //if ( this.check_options.get_boolean("show-date") == true ) {
        if (1) {
            // Get date:
            year = now.getFullYear();
            month = ( now.getMonth() + 1 );
            if ( month < 10 ) {
                month = "0" + month;
            }
            day = now.getDate();
            if ( day < 10 ) {
                day = "0" + day;
            }

            // Get the day's name:
            days = ["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"];
            months = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];

			let onejan = new Date(now.getFullYear(), 0, 1);
			//week = Math.ceil( (((now - onejan) / 86400000) + onejan.getDay() + 1) / 7 );
			week = Math.ceil( (((now - onejan) / 86400000) + onejan.getDay()) / 7 );
            //week = this.getWeek();
            
            //my_date = year+"-"+month+"-"+day+"  ";
            my_date = day + " " + months[month - 1] + " " + year + "  Week " + week + "  ";
            //my_date = day + "-" + months[month - 1] + "-" + year + "  ";
            my_today = days[now.getDay()] + "  ";

        } else {
            my_date = ""
            my_today = ""
        }

        // Get time:
        hours = now.getHours();
        /*
        if ( hours < 10 ) {
            hours = "0"+hours;
        }
        */
        minutes = now.getMinutes();
        if ( minutes < 10 ) {
            minutes = "0" + minutes;
        }
        
        // Check if seconds should be displayed:
        //if ( this.check_options.get_boolean("show-seconds") == true ) {
        if (0) {
            seconds = now.getSeconds();
            if ( seconds < 10 ) {
                seconds = "0"+seconds;
            }
            my_time = hours + ":" + minutes + ":" + seconds;
        } else {
            my_time = hours + ":" + minutes;
        }

        // Set labels:
        this.full_date.set_text(my_date);
        this.full_time.set_text(my_time);
        this.full_day.set_text(my_today);
    },

    on_timeout: function() {
        this.MakeClock();
        return this.run;
    },

    enable: function() {
        this.date_menu.actor.remove_actor(this.orig_clock);
        this.date_menu.actor.add_actor(this.full_clock);
        this.run = true;

        this.on_timeout();
        this._update_handler = Mainloop.timeout_add(UPDATE_INTERVAL, Lang.bind(this, this.on_timeout));
    },

    disable: function() {
        this.run = false;
        if (this._update_handler) Mainloop.source_remove(this._update_handler);

        this.date_menu.actor.remove_actor(this.full_clock);
        this.date_menu.actor.add_actor(this.orig_clock);
    }
}

function init() {
    return new FullClock();
}
